#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>

// Doppelt verkettete Liste: Verbindung Luebeck - Muenchen

// Knoten 'bahnhof' mit zeigern auf suedlichen und noerdlichen Nachfolger

struct bahnhof
{
	char bname [25] ;
	struct bahnhof* sued;
   struct bahnhof* nord;
};

// Funktion liefert den Namen des j-ten Knoten zurueck
 
char* ortsname (int j) 
{
	char *ort [] =
	{
		"Muenchen"   ,
		"Augsburg"   ,
		"Ulm"        ,
		"Stuttgart"  ,
		"Heidelberg" ,
		"Mannheim"   ,
		"Frankfurt"  ,
		"Kassel"     ,
		"Goettingen" ,
		"Hannover"   ,
		"Hamburg"    ,
		"Luebeck" 
	} ;

	return ort [j] ;
}

// Hauptfunktion

void main () 
{

	// Deklaration von Zeigern auf Knoten des Datentyps 'bahnhof'


	struct bahnhof  *strecke , *ende , *start, *station , *pBackup ;
	int i = 0 ;

	// Erster Knoten wird initialisiert

   ende = NULL ;
   	
	strecke = ( bahnhof* ) malloc ( sizeof(bahnhof) ) ;
	strcpy ( strecke->bname , ortsname (11)) ;

    strecke->sued = ( bahnhof* ) malloc ( sizeof(bahnhof) ) ;
    strcpy ( strecke->sued->bname , ortsname (10)) ;

	strecke->nord = ende ;

    strecke->sued->nord = strecke ;

	// Erster Knoten wir in 'pBackup' gesichert

	pBackup = strecke ;

	// Restliche Knoten werden initialisiert

	for ( i = 10 ; i >= 0 ; i-- )
	{
		ende = strecke ;

		strecke = ( bahnhof* ) malloc ( sizeof (bahnhof) ) ;

		strcpy ( strecke->bname , ortsname (i)) ;

		strecke->nord = ende ;

      strecke->sued = ende->sued ;

	  	strecke->sued->nord = strecke ;

      ende->sued = strecke ;
	}

	// Letzter Knoten wird in 'start' gesichert

	start = strecke  ;
	start->sued = NULL ;

	// Kontrolle: Doppelt verkettete Liste wird ausgegeben
	// Erster Knoten 'Luebeck' von 'pBackup' an Listenzeiger zuweisen

	strecke = pBackup ;

	// Kontrolle: Doppelt verkettete Liste ausgeben.

	printf ("Doppelt verkettete Liste kontrollieren. Weiter mit beliebiger Taste ... \n\n" ) ;

    getch () ;

	for ( i = 11 ; i >= 0 ; i-- )
	{
		printf ("bahnhof=\t%s\n" , strecke->bname ) ;
		printf ("strecke->nord=\t%s\n" , strecke->nord->bname ) ;
		printf ("strecke->sued=\t%s\n\n", strecke->sued->bname ) ;

      strecke = strecke->sued  ;

		printf ("Weiter mit beliebiger Taste ... \n\n" ) ;
		getch () ;
	}

	// Zeiger 'station' iitialisieren

	station = ( bahnhof* ) malloc ( sizeof ( bahnhof )) ;
	station->nord = NULL ;
	system ("cls") ;

	// Noerdliche Verbindung anzeigen. Startbahnhof Luebeck und Zielbahnhof Muenchen mit Haltepunkten

	printf ( "Noerdliche Route 'M -> HL' mit Haltepunkten anzeigen\n" ) ;
	printf ( " Weiter mit beliebiger Taste ... \n\n" ) ;
    getch () ;
	system ("cls") ;

	printf  ( "Noerdliche Route: Muenchen -> Luebeck\n\n" ) ;

	for ( station = start ; station != NULL ; station = station->nord )
	{
		printf ("%s\n" , station->bname ) ;
	}

	printf ( "\n\n Weiter mit beliebiger Taste ... \n\n" ) ;
	getch () ;

	// Suedliche Verbindung anzeigen. Startbahnhof Muenchen und Zielbahnhof Luebeck mit Haltepunkten

	printf  ( "Suedliche Route 'HL -> M' mit Haltepunkten anzeigen\n" ) ;
	printf (" Weiter mit beliebiger Taste ... \n\n" ) ;
	
	system ("cls") ;


	printf  ( "Suedliche Route: Luebeck -> Muenchen\n\n" ) ;

	for ( station = pBackup ; station != start->sued ; station = station->sued )
	{
		printf ("%s\n" , station->bname ) ;
	}

   	printf ( "\n\n Weiter mit beliebiger Taste ... \n\n" ) ;
	getch () ;

	system ("cls") ;

   // Speicherplatz freigeben

   free (strecke) ;   
   free (ende)    ;
   free (start)   ;
   free (station) ;
   free (pBackup) ;
   

}